Solid Example: Store Actions

import { render } from 'solid-js/web'
import { createStore, _useStore, useSelector } from '@tanstack/solid-store'

// Optionally, you can create stores outside of Solid components at module scope
const petStore = createStore(
  {
    cats: 0,
    dogs: 0,
  },
  ({ setState, get }) =>
    // optionally, define actions for updating your store in specific ways right on the store.
    ({
      addCat: () =>
        setState((prev) => ({
          ...prev,
          cats: prev.cats + 1,
        })),
      addDog: () =>
        setState((prev) => ({
          ...prev,
          dogs: prev.dogs + 1,
        })),
      log: () => console.log(get()),
    }),
)

function App() {
  return (
    <main>
      <button type="button" onClick={petStore.actions.log}>
        Log State
      </button>
      <h1>Solid Store Actions</h1>
      <p>
        This example creates a module-level store with actions. Components read
        state with <code>useSelector</code> and call mutations through{' '}
        <code>store.actions</code> or the experimental <code>_useStore</code>{' '}
        hook.
      </p>
      <CatVoter />
      <DogVoter />
      <TotalCard />
    </main>
  )
}

function CatVoter() {
  const cats = useSelector(petStore, (state) => state.cats)
  const { addCat } = petStore.actions

  return (
    <div>
      <p>Cats: {cats()}</p>
      <button type="button" onClick={() => addCat()}>
        Vote for cats
      </button>
    </div>
  )
}

function DogVoter() {
  // _useStore gives both the selected state and actions in a single tuple
  const [dogs, { addDog }] = _useStore(petStore, (state) => state.dogs)

  return (
    <div>
      <p>Dogs: {dogs()}</p>
      <button type="button" onClick={() => addDog()}>
        Vote for dogs
      </button>
    </div>
  )
}

function TotalCard() {
  const total = useSelector(petStore, (state) => state.cats + state.dogs)

  return <p>Total votes: {total()}</p>
}

render(() => <App />, document.getElementById('root')!)
import { render } from 'solid-js/web'
import { createStore, _useStore, useSelector } from '@tanstack/solid-store'

// Optionally, you can create stores outside of Solid components at module scope
const petStore = createStore(
  {
    cats: 0,
    dogs: 0,
  },
  ({ setState, get }) =>
    // optionally, define actions for updating your store in specific ways right on the store.
    ({
      addCat: () =>
        setState((prev) => ({
          ...prev,
          cats: prev.cats + 1,
        })),
      addDog: () =>
        setState((prev) => ({
          ...prev,
          dogs: prev.dogs + 1,
        })),
      log: () => console.log(get()),
    }),
)

function App() {
  return (
    <main>
      <button type="button" onClick={petStore.actions.log}>
        Log State
      </button>
      <h1>Solid Store Actions</h1>
      <p>
        This example creates a module-level store with actions. Components read
        state with <code>useSelector</code> and call mutations through{' '}
        <code>store.actions</code> or the experimental <code>_useStore</code>{' '}
        hook.
      </p>
      <CatVoter />
      <DogVoter />
      <TotalCard />
    </main>
  )
}

function CatVoter() {
  const cats = useSelector(petStore, (state) => state.cats)
  const { addCat } = petStore.actions

  return (
    <div>
      <p>Cats: {cats()}</p>
      <button type="button" onClick={() => addCat()}>
        Vote for cats
      </button>
    </div>
  )
}

function DogVoter() {
  // _useStore gives both the selected state and actions in a single tuple
  const [dogs, { addDog }] = _useStore(petStore, (state) => state.dogs)

  return (
    <div>
      <p>Dogs: {dogs()}</p>
      <button type="button" onClick={() => addDog()}>
        Vote for dogs
      </button>
    </div>
  )
}

function TotalCard() {
  const total = useSelector(petStore, (state) => state.cats + state.dogs)

  return <p>Total votes: {total()}</p>
}

render(() => <App />, document.getElementById('root')!)

Vue Example: Store Actions

<script setup lang="ts">
import { createStore, _useStore, useSelector } from '@tanstack/vue-store'

// Optionally, you can create stores outside of Vue components at module scope
const petStore = createStore(
  {
    cats: 0,
    dogs: 0,
  },
  ({ setState, get }) =>
    // optionally, define actions for updating your store in specific ways right on the store.
    ({
      addCat: () =>
        setState((prev: { cats: number; dogs: number }) => ({
          ...prev,
          cats: prev.cats + 1,
        })),
      addDog: () =>
        setState((prev: { cats: number; dogs: number }) => ({
          ...prev,
          dogs: prev.dogs + 1,
        })),
      log: () => console.log(get()),
    }),
)

// Read via useSelector and grab actions directly from the store
const cats = useSelector(petStore, (state) => state.cats)
const { addCat } = petStore.actions

// _useStore gives both the selected state and actions in a single tuple
const [dogs, { addDog }] = _useStore(petStore, (state) => state.dogs)

const total = useSelector(petStore, (state) => state.cats + state.dogs)
</script>

<template>
  <main>
    <button type="button" @click="petStore.actions.log()">Log State</button>
    <h1>Vue Store Actions</h1>
    <p>
      This example creates a module-level store with actions. Components read
      state with <code>useSelector</code> and call mutations through
      <code>store.actions</code> or the experimental <code>_useStore</code>
      hook.
    </p>
    <div>
      <p>Cats: {{ cats }}</p>
      <button type="button" @click="addCat()">Vote for cats</button>
    </div>
    <div>
      <p>Dogs: {{ dogs }}</p>
      <button type="button" @click="addDog()">Vote for dogs</button>
    </div>
    <p>Total votes: {{ total }}</p>
  </main>
</template>
<script setup lang="ts">
import { createStore, _useStore, useSelector } from '@tanstack/vue-store'

// Optionally, you can create stores outside of Vue components at module scope
const petStore = createStore(
  {
    cats: 0,
    dogs: 0,
  },
  ({ setState, get }) =>
    // optionally, define actions for updating your store in specific ways right on the store.
    ({
      addCat: () =>
        setState((prev: { cats: number; dogs: number }) => ({
          ...prev,
          cats: prev.cats + 1,
        })),
      addDog: () =>
        setState((prev: { cats: number; dogs: number }) => ({
          ...prev,
          dogs: prev.dogs + 1,
        })),
      log: () => console.log(get()),
    }),
)

// Read via useSelector and grab actions directly from the store
const cats = useSelector(petStore, (state) => state.cats)
const { addCat } = petStore.actions

// _useStore gives both the selected state and actions in a single tuple
const [dogs, { addDog }] = _useStore(petStore, (state) => state.dogs)

const total = useSelector(petStore, (state) => state.cats + state.dogs)
</script>

<template>
  <main>
    <button type="button" @click="petStore.actions.log()">Log State</button>
    <h1>Vue Store Actions</h1>
    <p>
      This example creates a module-level store with actions. Components read
      state with <code>useSelector</code> and call mutations through
      <code>store.actions</code> or the experimental <code>_useStore</code>
      hook.
    </p>
    <div>
      <p>Cats: {{ cats }}</p>
      <button type="button" @click="addCat()">Vote for cats</button>
    </div>
    <div>
      <p>Dogs: {{ dogs }}</p>
      <button type="button" @click="addDog()">Vote for dogs</button>
    </div>
    <p>Total votes: {{ total }}</p>
  </main>
</template>

React Example: Store Actions

import ReactDOM from 'react-dom/client'
import { createStore, _useStore, useSelector } from '@tanstack/react-store'

// Optionally, you can create stores outside of React components at module scope
const petStore = createStore(
  {
    cats: 0,
    dogs: 0,
  },
  ({ setState, get }) =>
    // optionally, define actions for updating your store in specific ways right on the store.
    ({
      addCat: () =>
        setState((prev) => ({
          ...prev,
          cats: prev.cats + 1,
        })),
      addDog: () =>
        setState((prev) => ({
          ...prev,
          dogs: prev.dogs + 1,
        })),
      log: () => console.log(get()),
    }),
)

function App() {
  // or define stores inside of components with hook variant. You would have to pass store as props or use store context though.
  // const petStore = useCreateStore(...)

  return (
    <main>
      <button onClick={petStore.actions.log}>Log State</button>
      <h1>React Store Actions</h1>
      <p>
        This example creates a module-level store with actions. Components read
        state with <code>useSelector</code> and call mutations through{' '}
        <code>store.actions</code> or the experimental <code>_useStore</code>{' '}
        hook.
      </p>
      <CatVoter />
      <DogVoter />
      <TotalCard />
    </main>
  )
}

function CatVoter() {
  const cats = useSelector(petStore, (state) => state.cats)
  const { addCat } = petStore.actions

  return (
    <div>
      <p>Cats: {cats}</p>
      <button type="button" onClick={() => addCat()}>
        Vote for cats
      </button>
    </div>
  )
}

function DogVoter() {
  // _useStore gives both the selected state and actions in a single tuple
  const [dogs, { addDog }] = _useStore(petStore, (state) => state.dogs)

  return (
    <div>
      <p>Dogs: {dogs}</p>
      <button type="button" onClick={() => addDog()}>
        Vote for dogs
      </button>
    </div>
  )
}

function TotalCard() {
  const total = useSelector(petStore, (state) => state.cats + state.dogs)

  return <p>Total votes: {total}</p>
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(<App />)
import ReactDOM from 'react-dom/client'
import { createStore, _useStore, useSelector } from '@tanstack/react-store'

// Optionally, you can create stores outside of React components at module scope
const petStore = createStore(
  {
    cats: 0,
    dogs: 0,
  },
  ({ setState, get }) =>
    // optionally, define actions for updating your store in specific ways right on the store.
    ({
      addCat: () =>
        setState((prev) => ({
          ...prev,
          cats: prev.cats + 1,
        })),
      addDog: () =>
        setState((prev) => ({
          ...prev,
          dogs: prev.dogs + 1,
        })),
      log: () => console.log(get()),
    }),
)

function App() {
  // or define stores inside of components with hook variant. You would have to pass store as props or use store context though.
  // const petStore = useCreateStore(...)

  return (
    <main>
      <button onClick={petStore.actions.log}>Log State</button>
      <h1>React Store Actions</h1>
      <p>
        This example creates a module-level store with actions. Components read
        state with <code>useSelector</code> and call mutations through{' '}
        <code>store.actions</code> or the experimental <code>_useStore</code>{' '}
        hook.
      </p>
      <CatVoter />
      <DogVoter />
      <TotalCard />
    </main>
  )
}

function CatVoter() {
  const cats = useSelector(petStore, (state) => state.cats)
  const { addCat } = petStore.actions

  return (
    <div>
      <p>Cats: {cats}</p>
      <button type="button" onClick={() => addCat()}>
        Vote for cats
      </button>
    </div>
  )
}

function DogVoter() {
  // _useStore gives both the selected state and actions in a single tuple
  const [dogs, { addDog }] = _useStore(petStore, (state) => state.dogs)

  return (
    <div>
      <p>Dogs: {dogs}</p>
      <button type="button" onClick={() => addDog()}>
        Vote for dogs
      </button>
    </div>
  )
}

function TotalCard() {
  const total = useSelector(petStore, (state) => state.cats + state.dogs)

  return <p>Total votes: {total}</p>
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(<App />)

Angular Example: Store Actions

import { Component } from '@angular/core'
import {
  _injectStore,
  createStore,
  injectSelector,
} from '@tanstack/angular-store'

// Optionally, you can create stores outside of Angular components at module scope
const petStore = createStore(
  {
    cats: 0,
    dogs: 0,
  },
  ({ setState, get }) =>
    // optionally, define actions for updating your store in specific ways right on the store.
    ({
      addCat: () =>
        setState((prev) => ({
          ...prev,
          cats: prev.cats + 1,
        })),
      addDog: () =>
        setState((prev) => ({
          ...prev,
          dogs: prev.dogs + 1,
        })),
      log: () => console.log(get()),
    }),
)

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <main>
      <button type="button" (click)="log()">Log State</button>
      <h1>Angular Store Actions</h1>
      <p>
        This example creates a module-level store with actions. Components read
        state with \`injectSelector\` and call mutations through
        \`store.actions\` or the experimental \`_injectStore\` hook.
      </p>
      <div>
        <p>Cats: {{ cats() }}</p>
        <button type="button" (click)="addCat()">Vote for cats</button>
      </div>
      <div>
        <p>Dogs: {{ dogs() }}</p>
        <button type="button" (click)="dogActions.addDog()">
          Vote for dogs
        </button>
      </div>
      <p>Total votes: {{ total() }}</p>
    </main>
  `,
})
export class AppComponent {
  // Read via injectSelector and grab actions directly from the store
  cats = injectSelector(petStore, (state) => state.cats)
  addCat = petStore.actions.addCat

  // _injectStore gives both the selected signal and actions in a single tuple
  private dogResult = _injectStore(petStore, (state) => state.dogs)
  dogs = this.dogResult[0]
  dogActions = this.dogResult[1]

  total = injectSelector(petStore, (state) => state.cats + state.dogs)

  log() {
    petStore.actions.log()
  }
}
import { Component } from '@angular/core'
import {
  _injectStore,
  createStore,
  injectSelector,
} from '@tanstack/angular-store'

// Optionally, you can create stores outside of Angular components at module scope
const petStore = createStore(
  {
    cats: 0,
    dogs: 0,
  },
  ({ setState, get }) =>
    // optionally, define actions for updating your store in specific ways right on the store.
    ({
      addCat: () =>
        setState((prev) => ({
          ...prev,
          cats: prev.cats + 1,
        })),
      addDog: () =>
        setState((prev) => ({
          ...prev,
          dogs: prev.dogs + 1,
        })),
      log: () => console.log(get()),
    }),
)

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <main>
      <button type="button" (click)="log()">Log State</button>
      <h1>Angular Store Actions</h1>
      <p>
        This example creates a module-level store with actions. Components read
        state with \`injectSelector\` and call mutations through
        \`store.actions\` or the experimental \`_injectStore\` hook.
      </p>
      <div>
        <p>Cats: {{ cats() }}</p>
        <button type="button" (click)="addCat()">Vote for cats</button>
      </div>
      <div>
        <p>Dogs: {{ dogs() }}</p>
        <button type="button" (click)="dogActions.addDog()">
          Vote for dogs
        </button>
      </div>
      <p>Total votes: {{ total() }}</p>
    </main>
  `,
})
export class AppComponent {
  // Read via injectSelector and grab actions directly from the store
  cats = injectSelector(petStore, (state) => state.cats)
  addCat = petStore.actions.addCat

  // _injectStore gives both the selected signal and actions in a single tuple
  private dogResult = _injectStore(petStore, (state) => state.dogs)
  dogs = this.dogResult[0]
  dogActions = this.dogResult[1]

  total = injectSelector(petStore, (state) => state.cats + state.dogs)

  log() {
    petStore.actions.log()
  }
}